<template>
  <Row class="manager-stock-data-keyword">
    <i-col :span="12" class="content-block">
      <stock-search-block
          :fields="search.fields"
          :default-field="search.column"
          @on-search="searchAction">
        <template>
          <stock-company-card v-for="(company, index) in companiesToShow" :key="`${timestamp}-${index}`"
                              :lg="8" :md="8"
                              :company="company" @on-click="showCompanyKeywordsAction(company.id)">
          </stock-company-card>
        </template>
      </stock-search-block>
    </i-col>

    <i-col :span="12" class="content-block">
      <div class="tool-block">
        <input class="new-keyword-input inline-block" v-model="newKeyword"
               :placeholder="newKeywordPlaceholder()" @keyup.enter="addNewKeywordAction()">
        </input>
        <div class="add-new-keyword-btn div-btn inline-block" @click="addNewKeywordAction()">
          <Icon type="md-add"></Icon>
        </div>
      </div>
      <Row class="company-keyword-list" :gutter="4">
        <i-col class="keyword-item"
               :lg="8" :md="8" :sm="12" :xs="24"
               v-for="(keyword, index) in companyKeyWords" :key="`${timestamp}-${index}`">
          <div class="keyword-name overflow-dot inline-block">{{keyword.name}}</div>
          <div class="remove-keyword div-btn inline-block" @click="removeKeywordAction(keyword.id, index)">
            <Icon type="md-trash"></Icon>
          </div>
        </i-col>
      </Row>
    </i-col>
  </Row>
</template>

<script>
import StockSearchBlock from "../../../components/StockSearchBlock";
import StockCompanyCard from "../../../components/StockCompanyCard";
import { validators as api } from '../../../configs/request-validator/company';

const actions = {
  searchAction({ searchColumn, searchValue }) {
    this.search.column = searchColumn;
    this.search.value = searchValue;
  },
  showCompanyKeywordsAction(companyId) {
    this.focusCompanyId = companyId;
  },
  async addNewKeywordAction() {
    const requestData = {
      companyId: this.focusCompanyId,
      keyword: this.newKeyword,
    };

    try {
      const { data } = await this.$api(api.AddCompanyKeywordRequest, requestData);
      this.companies[this.focusCompanyId]['keywords'] = data['keywords'];
      this.newKeyword = undefined;
    } catch (error) {
      this.$apiErrorHandler(error);
    }
  },
  async removeKeywordAction(keywordId, index) {
    const requestData = {
      companyId: this.focusCompanyId,
      keywordId: keywordId,
    };

    try {
      await this.$api(api.RemoveCompanyKeywordRequest, requestData);
      this.companies[this.focusCompanyId]['keywords'].splice(index, 1);
    } catch (error) {
      this.$apiErrorHandler(error);
    }
  },
};

export default {
  name: 'keyword',
  components: {StockCompanyCard, StockSearchBlock},
  data() {
    return {
      companies: undefined,
      search: {
        column: 'stockCode',
        value: undefined,
        fields: [
          { value: 'id', label: 'ID' },
          { value: 'stockCode', label: 'Code' },
          { value: 'name', label: 'Name' },
        ]
      },
      companiesToShow: [],
      focusCompanyId: undefined,
      newKeyword: undefined,
      timestamp: new Date().getTime(),
    };
  },
  computed: {
    companyKeyWords() {
      if (this.focusCompanyId) {
        return this.companies[this.focusCompanyId].keywords;
      }
      return [];
    },
  },
  watch: {
    ['search.column']() {
      this.rerenderCompaniesToShow();
    },
    ['search.value']() {
      this.rerenderCompaniesToShow();
    },
  },
  methods: {
    ...actions,
    rerenderCompaniesToShow() {
      this.companiesToShow = [];
      const toFilter = this.search.column && this.search.value;
      const getAll = !this.search.value;
      if (toFilter) {
        Object.keys(this.companies).forEach(key => {
          const company = this.companies[key];
          const matchFilter = company[this.search.column].toString().includes(this.search.value);
          if (matchFilter) {
            this.companiesToShow.push(company);
          }
        });
      } else if (getAll) {
        this.companiesToShow = this.companies;
      }
      this.forceRender();
    },
    forceRender() {
      this.timestamp = new Date().getTime();
    },
    newKeywordPlaceholder() {
      const companyStockCode = (this.focusCompanyId)
        ? this.companies[this.focusCompanyId].stockCode
        : '...';
      return `new keyword for ${companyStockCode}`;
    },
  },
  mounted() {
    this.$displayBodyBlock(false);
    this.rerenderCompaniesToShow();
  },
  async asyncData({ app, store }) {
    let companies = undefined;
    const hasCompanies = store.getters['company/hasCompanies'];

    if (hasCompanies) {
      companies = store.getters['company/companies'];
    } else {
      // request
      const companiesData = {};

      // invoke api
      try {
        const allResponseData = await Promise.all([
          app.$api(api.GetAllCompanyRequest, companiesData, undefined, false),
        ]);

        // set vue data
        companies = allResponseData[0]['data'];

        // store in vuex
        store.dispatch('company/setCompanies', companies);
      } catch (error) {
        app.$apiErrorHandler(error);
      }
    }

    return { companies };
  }
}
</script>

<style lang="scss" scoped>
  .manager-stock-data-keyword {
    height: 100%;
    .content-block {
      height: 100%;
      padding: 10px 15px;
      overflow-y: auto;
      .tool-block {
        height: 80px;
        padding: 10px 0;
        line-height: 60px;
        vertical-align: middle;
        .new-keyword-input {
          width: 300px;
          height: 40px;
          padding: 15px;
          border-top-left-radius: 8px;
          border-bottom-left-radius: 8px;
          border: 0;
          font-size: 20px;
          vertical-align: bottom;
          &:focus {
            outline: none;
          }
        }
        .add-new-keyword-btn {
          width: 40px;
          height: 40px;
          border-top-right-radius: 8px;
          border-bottom-right-radius: 8px;
          margin-left: -5px;
          vertical-align: bottom;
          font-size: 20px;
          line-height: 34px;
          text-align: center;
        }
      }
      .company-keyword-list {
        height: calc(100% - 90px);
        padding: 30px 10px 10px 10px;
        border-radius: 4px;
        overflow-y: auto;
        .keyword-item {
          height: 40px;
          margin-bottom: 15px;
          .keyword-name {
            width: calc(100% - 40px - 20px);
            height: 100%;
            padding: 4px 35px;
            border-top-left-radius: 8px;
            border-bottom-left-radius: 8px;
            line-height: 32px;
            vertical-align: middle;
            font-size: 16px;
            font-weight: bold;
          }
          .remove-keyword {
            width: 40px;
            height: 40px;
            border-top-right-radius: 8px;
            border-bottom-right-radius: 8px;
            margin-left: -5px;
            font-size: 20px;
            text-align: center;
            line-height: 35px;
            vertical-align: middle;
          }
        }
      }
    }
  }
</style>
